// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMClarion.pas' rev: 3.00

#ifndef SMClarionHPP
#define SMClarionHPP
#include <SMCells.hpp>
#include <Windows.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smclarion
{
//-- type declarations -------------------------------------------------------
enum TClarionFieldType { cftUnknown, cftLong, cftReal, cftString, cftPicString, cftByte, cftShort, cftGroup, 
	cftDecimal, cftMemo, cftSubGroup };

#pragma pack(push, 1)
struct TClarionField
{
	Byte FieldType;
	char FieldName[16];
	Word StartPos;
	Word Length;
	Byte Decimals;
	Byte Precision;
	Word ArrayNum;
	Word PicNum;
} ;
#pragma pack(pop)

typedef TClarionField TClarionFields[4096];

#pragma pack(push, 1)
struct TClarionKey
{
	Byte NumComps;
	char KeyNames[16];
	Byte CompType;
	Byte CompLen;
} ;
#pragma pack(pop)

struct TClarionKeyItem;
typedef TClarionKeyItem *PClarionKeyItem;

#pragma pack(push, 1)
struct TClarionKeyItem
{
	Byte FieldType;
	Word FieldNum;
	Word ElementOffset;
	Byte ElementLen;
} ;
#pragma pack(pop)

class DELPHICLASS TClarionKeyValue;
class PASCALIMPLEMENTATION TClarionKeyValue : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TClarionKey KeyInfo;
	Classes::TList* Items;
	void __fastcall AddItem(const TClarionKeyItem &cki);
	void __fastcall ClearItems(void);
	System::AnsiString __fastcall GetTypeStr();
	__fastcall virtual ~TClarionKeyValue(void);
public:
	/* TObject.Create */ __fastcall TClarionKeyValue(void) : System::TObject() { }
	
};

class DELPHICLASS TClarionKeys;
class PASCALIMPLEMENTATION TClarionKeys : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	TClarionKeyValue* __fastcall AddKey(void);
	void __fastcall DeleteKey(TClarionKeyValue* Value);
	void __fastcall ClearItems(void);
	__fastcall virtual ~TClarionKeys(void);
public:
	/* TObject.Create */ __fastcall TClarionKeys(void) : Classes::TList() { }
	
};

#pragma pack(push, 1)
struct TClarionPicture
{
	Word PicLen;
	char PicStr[256];
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TClarionArrayHeader
{
	Word NumDim;
	Word TotalDim;
	Word ElementSize;
} ;
#pragma pack(pop)

class DELPHICLASS TClarionArrayItem;
class PASCALIMPLEMENTATION TClarionArrayItem : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	Word MaxDim;
	Word LenDim;
public:
	/* TObject.Create */ __fastcall TClarionArrayItem(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TClarionArrayItem(void) { }
	
};

class DELPHICLASS TClarionArray;
class PASCALIMPLEMENTATION TClarionArray : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TClarionArrayHeader Header;
	Classes::TList* Items;
public:
	/* TObject.Create */ __fastcall TClarionArray(void) : System::TObject() { }
	/* TObject.Destroy */ __fastcall virtual ~TClarionArray(void) { }
	
};

#pragma pack(push, 1)
struct TClarionHeader
{
	Word Signature;
	Word Attribute;
	Byte NumberOfKeys;
	int NumberOfRecords;
	int NumberOfDeleted;
	Word NumberOfFields;
	Word NumberOfPictures;
	Word NumberOfArrays;
	Word RecordSize;
	int Offset;
	int LogicalEOF;
	int LogicalBOF;
	int FirstFreeRec;
	char RecName[12];
	char MemoName[12];
	char FileNamePrefix[3];
	char RecNamePrefix[3];
	Word MemoLength;
	Word MemoColWidth;
	int LockCount;
	int LastUpdateTime;
	int LastUpdateDate;
	Word CheckSum;
} ;
#pragma pack(pop)

enum TClarionRecordStatus { crsNew, crsOld, crsRevised, crsDeleted, crsHeld };

#pragma pack(push, 1)
struct TClarionRecordHeader
{
	TClarionRecordStatus Status;
	int NextDeleted;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TClarionMEMOHeader
{
	Word Signature;
	int FirstDeleted;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TClarionMEMORecord
{
	int NextBlock;
	char MemoBlock[252];
} ;
#pragma pack(pop)

class DELPHICLASS TClarion;
class PASCALIMPLEMENTATION TClarion : public Smcells::TSpreadSheetFile 
{
	typedef Smcells::TSpreadSheetFile inherited;
	
private:
	Word FID;
	Classes::TStream* BLOBStream;
	bool FAutoPatchFieldNames;
	bool FDateAutodetect;
	System::AnsiString FPassword;
	void __fastcall SetPassword(System::AnsiString AValue);
	bool __fastcall CheckHeader(void);
	void __fastcall DecodeBuffer(void *Buffer, Word ASize);
	TClarionArray* __fastcall GetClarionArrayByField(const TClarionField &fld);
	void __fastcall ClearArrays(void);
	int __fastcall GetMemoBlockNo(int Value);
	
protected:
	Classes::TStream* FCurrentStream;
	virtual void __fastcall ReadBLOBValue(int BlockNo, int ASize, System::AnsiString &s);
	void __fastcall GetFieldValue(const TClarionField &Field, const System::AnsiString strBuffer, System::Variant 
		&Value, Smcells::TSMICellType &CellType);
	
public:
	TClarionHeader DBHeader;
	TClarionField Fields[4096];
	TClarionKeys* Keys;
	Classes::TList* ArrayFields;
	__fastcall virtual TClarion(Classes::TComponent* AOwner);
	__fastcall virtual ~TClarion(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* AStream);
	virtual void __fastcall LoadFromFile(const System::WideString FileName);
	virtual void __fastcall BeforeLoad(void);
	virtual void __fastcall AfterLoad(void);
	virtual bool __fastcall LoadRecord(int RecNo);
	System::TDateTime __fastcall GetLastUpdate(void);
	bool __fastcall IsLocked(void);
	virtual bool __fastcall IsEncrypted(void);
	bool __fastcall IsOwned(void);
	bool __fastcall IsMemoExist(void);
	System::AnsiString __fastcall GetStrFieldType(Byte AType);
	/*         class method */ static System::TDateTime __fastcall GetDate(System::TMetaClass* vmt, int 
		Value);
	/*         class method */ static System::TDateTime __fastcall GetTime(System::TMetaClass* vmt, int 
		Value);
	
__published:
	__property bool DateAutodetect = {read=FDateAutodetect, write=FDateAutodetect, default=1};
	__property bool AutoPatchFieldNames = {read=FAutoPatchFieldNames, write=FAutoPatchFieldNames, default=1
		};
	__property System::AnsiString Password = {read=FPassword, write=SetPassword};
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE System::AnsiString arrClarionFieldTypeStr[11];
#define CS_LOCKED (Byte)(1)
#define CS_OWNED (Byte)(2)
#define CS_ENCRYPTED (Byte)(4)
#define CS_MEMOEXIST (Byte)(8)
#define CS_COMPRESSED (Byte)(16)
#define CS_RECLAIM (Byte)(32)
#define CS_READONLY (Byte)(64)
#define CS_CREATED (Byte)(128)

}	/* namespace Smclarion */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smclarion;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMClarion
