// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIBase.pas' rev: 3.00

#ifndef SMIBaseHPP
#define SMIBaseHPP
#include <SMIPars.hpp>
#include <SMIStat.hpp>
#include <Db.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <StdCtrls.hpp>
#include <Dialogs.hpp>
#include <Forms.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smibase
{
//-- type declarations -------------------------------------------------------
enum TTableTypeImport { teParadox, teDBase, teText, teHTML, teXLS, teWKS, teQuattro, teXML, teAccess, 
	teWord, teADO, teSPSS, teADT, teDBISAM, teClarion, teClipboard, teWAB, teVCalendar, teODS, teOutlook 
	};

typedef Set<TTableTypeImport, teParadox, teOutlook>  TImportFormatTypes;

enum TSMICharacterSet { csiANSI_WINDOWS, csiASCII_MSDOS, csiEBCDIC };

enum TImportMode { imAppend, imUpdate, imAppendUpdate, imDelete, imCopy, imAppendNewOnly };

typedef Set<TImportMode, imAppend, imAppendNewOnly>  TImportModes;

enum TSMIAction { iaUnknown, iaAdd, iaUpdate, iaDelete };

enum TSMIResult { irUnknown, irExecuted, irCanceled, irFailed };

enum TSMIFieldDelimiter { fdNone, fdCustom, fdTab, fdSemicolon, fdComma, fdSpace };

enum TSMITextQualifier { tqNone, tqCustom, tqQuot, tqApos };

enum TSMIRecordSeparator { rsCustom, rsCRLF, rsCR, rsLF };

typedef System::AnsiString TSMIAbout;

enum TSMIOption { soShowMessage, soExtendedStatistic, soSkipEmptyRow, soUseAnimatedControl, soWaitCursor, 
	soAutoCloseStatistic };

typedef Set<TSMIOption, soShowMessage, soAutoCloseStatistic>  TSMIOptions;

typedef void __fastcall (__closure *TBeforeRecordEvent)(System::TObject* Sender, const System::AnsiString 
	Fields, System::Variant &Values, bool &Accept);

typedef void __fastcall (__closure *TAfterRecordEvent)(System::TObject* Sender, bool &Abort);

typedef void __fastcall (__closure *TLocateRecordEvent)(System::TObject* Sender, const System::AnsiString 
	KeyFields, const System::Variant &Values, bool &Exist, bool &ExecuteLocate);

typedef void __fastcall (__closure *TBeforeFieldEvent)(System::TObject* Sender, Db::TField* Field, System::Variant 
	&Value, bool &Accept);

typedef void __fastcall (__closure *TSMIGetRowMode)(System::TObject* Sender, const System::Variant &
	Values, TImportMode &AModeForRow);

typedef void __fastcall (__closure *TGetCellParamsEvent)(System::TObject* Sender, Db::TField* Field, 
	System::Variant &Value);

typedef void __fastcall (__closure *TErrorEvent)(System::TObject* Sender, Sysutils::Exception* Error
	, bool &Abort);

class DELPHICLASS TSMIStatistic;
class PASCALIMPLEMENTATION TSMIStatistic : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FTotalCount;
	int FTotalImported;
	int FTotalAdded;
	int FTotalDeleted;
	int FTotalUpdated;
	int FTotalErrors;
	int FTotalSkipped;
	int FUpdateStep;
	TSMIAction FLastAction;
	System::WideString FLastGeneratedSQL;
	TSMIResult FResult;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	__property System::WideString LastGeneratedSQL = {read=FLastGeneratedSQL};
	
__published:
	__property int TotalCount = {read=FTotalCount, write=FTotalCount, nodefault};
	__property int TotalImported = {read=FTotalImported, write=FTotalImported, stored=false, nodefault}
		;
	__property int TotalAdded = {read=FTotalAdded, write=FTotalAdded, stored=false, nodefault};
	__property int TotalDeleted = {read=FTotalDeleted, write=FTotalDeleted, stored=false, nodefault};
	__property int TotalUpdated = {read=FTotalUpdated, write=FTotalUpdated, stored=false, nodefault};
	__property int TotalErrors = {read=FTotalErrors, write=FTotalErrors, stored=false, nodefault};
	__property int TotalSkipped = {read=FTotalSkipped, write=FTotalSkipped, stored=false, nodefault};
	__property int UpdateStep = {read=FUpdateStep, write=FUpdateStep, default=1};
	__property TSMIAction LastAction = {read=FLastAction, write=FLastAction, stored=false, nodefault};
	__property TSMIResult Result = {read=FResult, write=FResult, nodefault};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMIStatistic(void) { }
	
public:
	/* TObject.Create */ __fastcall TSMIStatistic(void) : Classes::TPersistent() { }
	
};

enum TSMIDateOrder { doMDY, doDMY, doYMD, doYDM, doDYM, doMYD };

class DELPHICLASS TSMIDataFormats;
class PASCALIMPLEMENTATION TSMIDataFormats : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TSMIDateOrder FDateOrder;
	char FDateSeparator;
	char FTimeSeparator;
	bool FFourDigitYear;
	bool FLeadingZerosInDate;
	char FThousandSeparator;
	char FDecimalSeparator;
	System::AnsiString FCurrencyString;
	System::AnsiString FCustomDateTimeFormat;
	System::AnsiString FBooleanTrue;
	System::AnsiString FBooleanFalse;
	bool FUseRegionalSettings;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall LoadRegionalSettings(void);
	
__published:
	__property TSMIDateOrder DateOrder = {read=FDateOrder, write=FDateOrder, default=0};
	__property char DateSeparator = {read=FDateSeparator, write=FDateSeparator, nodefault};
	__property char TimeSeparator = {read=FTimeSeparator, write=FTimeSeparator, nodefault};
	__property bool FourDigitYear = {read=FFourDigitYear, write=FFourDigitYear, nodefault};
	__property bool LeadingZerosInDate = {read=FLeadingZerosInDate, write=FLeadingZerosInDate, nodefault
		};
	__property System::AnsiString CustomDateTimeFormat = {read=FCustomDateTimeFormat, write=FCustomDateTimeFormat
		};
	__property char ThousandSeparator = {read=FThousandSeparator, write=FThousandSeparator, nodefault};
		
	__property char DecimalSeparator = {read=FDecimalSeparator, write=FDecimalSeparator, nodefault};
	__property System::AnsiString CurrencyString = {read=FCurrencyString, write=FCurrencyString};
	__property System::AnsiString BooleanTrue = {read=FBooleanTrue, write=FBooleanTrue};
	__property System::AnsiString BooleanFalse = {read=FBooleanFalse, write=FBooleanFalse};
	__property bool UseRegionalSettings = {read=FUseRegionalSettings, write=FUseRegionalSettings, nodefault
		};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMIDataFormats(void) { }
	
public:
	/* TObject.Create */ __fastcall TSMIDataFormats(void) : Classes::TPersistent() { }
	
};

enum TSMIDataType { itString, itInteger, itFloat, itDateTime, itDate, itTime, itBoolean, itBLOB, itMEMO, 
	itGraphic };

class DELPHICLASS TSMIColumn;
class PASCALIMPLEMENTATION TSMIColumn : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	System::AnsiString FFieldName;
	System::AnsiString FCaption;
	TSMIDataType FDataType;
	int FSize;
	int FPrecision;
	TAlignment FAlignment;
	
public:
	__fastcall virtual TSMIColumn(Classes::TCollection* Collection);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property Classes::TAlignment Alignment = {read=FAlignment, write=FAlignment, default=0};
	__property System::AnsiString FieldName = {read=FFieldName, write=FFieldName};
	__property System::AnsiString Caption = {read=FCaption, write=FCaption};
	__property TSMIDataType DataType = {read=FDataType, write=FDataType, default=0};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property int Precision = {read=FPrecision, write=FPrecision, nodefault};
public:
	/* TCollectionItem.Destroy */ __fastcall virtual ~TSMIColumn(void) { }
	
};

class DELPHICLASS TSMIColumns;
class PASCALIMPLEMENTATION TSMIColumns : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMIControl;
	TSMIColumn* __fastcall GetColumn(int Index);
	void __fastcall SetColumn(int Index, TSMIColumn* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMIColumns(Classes::TComponent* SMICntrl);
	HIDESBASE TSMIColumn* __fastcall Add(void);
	__property TSMIColumn* Items[int Index] = {read=GetColumn, write=SetColumn/*, default*/};
	__property Classes::TComponent* SMIControl = {read=FSMIControl};
public:
	/* TCollection.Destroy */ __fastcall virtual ~TSMIColumns(void) { }
	
};

class DELPHICLASS TSMILoadCondition;
class PASCALIMPLEMENTATION TSMILoadCondition : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FLoadWhen;
	System::AnsiString FSkipIf;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property System::AnsiString LoadWhen = {read=FLoadWhen, write=FLoadWhen};
	__property System::AnsiString SkipIf = {read=FSkipIf, write=FSkipIf};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMILoadCondition(void) { }
	
public:
	/* TObject.Create */ __fastcall TSMILoadCondition(void) : Classes::TPersistent() { }
	
};

enum TSMIFieldCharCase { ifcNormal, ifcUpperCase, ifcLowerCase, ifcProper };

class DELPHICLASS TSMISQLFieldNameOptions;
class PASCALIMPLEMENTATION TSMISQLFieldNameOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	char FSQLQuoteOpen;
	char FSQLQuoteClose;
	
public:
	__fastcall virtual TSMISQLFieldNameOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property char SQLQuoteOpen = {read=FSQLQuoteOpen, write=FSQLQuoteOpen, default=91};
	__property char SQLQuoteClose = {read=FSQLQuoteClose, write=FSQLQuoteClose, default=93};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TSMISQLFieldNameOptions(void) { }
	
};

class DELPHICLASS TSMISQLOptions;
class PASCALIMPLEMENTATION TSMISQLOptions : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	System::AnsiString FSQLTerm;
	char FSQLQuote;
	TSMIFieldCharCase FFieldNameCharCase;
	TSMISQLFieldNameOptions* FFieldNameOptions;
	void __fastcall SetFieldNameOptions(TSMISQLFieldNameOptions* Value);
	
public:
	__fastcall virtual TSMISQLOptions(void);
	__fastcall virtual ~TSMISQLOptions(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property TSMIFieldCharCase FieldNameCharCase = {read=FFieldNameCharCase, write=FFieldNameCharCase
		, default=0};
	__property char SQLQuote = {read=FSQLQuote, write=FSQLQuote, default=34};
	__property System::AnsiString SQLTerm = {read=FSQLTerm, write=FSQLTerm};
	__property TSMISQLFieldNameOptions* FieldNameOptions = {read=FFieldNameOptions, write=SetFieldNameOptions
		};
};

typedef void __fastcall (__closure *TSMIOnCreateStructure)(System::TObject* Sender, TSMIColumns* Columns
	);

typedef void __fastcall (__closure *TSMISpecificationEvent)(System::TObject* Sender, System::AnsiString 
	&AFileName);

typedef void __fastcall (__closure *TSMIParsedValue)(System::TObject* Sender, Db::TField* Field, System::Variant 
	&Value);

enum TSMITrimSpaces { tsNoTrim, tsTrimRight, tsTrimLeft, tsTrimLeftRight };

enum TSMIActionKind { akDatasetApply, akGenerateSQL };

class DELPHICLASS TSMImportBaseComponent;
class PASCALIMPLEMENTATION TSMImportBaseComponent : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	System::AnsiString FAbout;
	bool FAnimatedStatus;
	bool FAbortOnProblem;
	Db::TDataSet* FDataSet;
	System::AnsiString FDatasetKeys;
	Classes::TStrings* FMappings;
	TImportMode FMode;
	TSMILoadCondition* FLoadCondition;
	TSMISQLOptions* FSQLOptions;
	TSMIActionKind FActionKind;
	TSMIOptions FOptions;
	System::AnsiString FTitleStatus;
	TSMIFieldDelimiter FFieldDelimiter;
	char FFieldDelimiterCustom;
	TSMITextQualifier FTextQualifier;
	char FTextQualifierCustom;
	TSMIRecordSeparator FRecordSeparator;
	System::AnsiString FRecordSeparatorCustom;
	bool FFixed;
	System::AnsiString FSourceFileName;
	int FRowFirst;
	int FRowLast;
	int FRowFieldNames;
	System::AnsiString FTableName;
	TSMICharacterSet FCharacterSet;
	TSMIDataFormats* FDataFormats;
	TTableTypeImport FTableType;
	TSMITrimSpaces FTrimSpaces;
	int FCommitCount;
	TErrorEvent FOnErrorEvent;
	TGetCellParamsEvent FOnGetCellParams;
	TSMIParsedValue FOnParsedValue;
	Smipars::TOnEvaluate FOnParserEvaluate;
	Classes::TNotifyEvent FOnBeforeExecute;
	Classes::TNotifyEvent FOnAfterExecute;
	TBeforeRecordEvent FOnBeforeRecordEvent;
	TAfterRecordEvent FOnAfterRecordEvent;
	Classes::TNotifyEvent FOnBeforeUpdate;
	TBeforeFieldEvent FOnBeforeFieldUpdate;
	TSMIGetRowMode FOnGetRowMode;
	TSMISpecificationEvent FOnBeforeLoadSpecification;
	TSMISpecificationEvent FOnAfterLoadSpecification;
	TSMISpecificationEvent FOnBeforeSaveSpecification;
	TSMISpecificationEvent FOnAfterSaveSpecification;
	TLocateRecordEvent FOnLocateRecord;
	Classes::TNotifyEvent FOnStartTransaction;
	Classes::TNotifyEvent FOnFinishTransaction;
	System::AnsiString FSpecificationDir;
	bool TransactionStarted;
	bool Abort;
	TSMIStatistic* FStatistic;
	bool FUseDisplayNames;
	TSMIColumns* FColumns;
	Smipars::TSMIParameters* FParameters;
	TSMIOnCreateStructure FOnCreateStructure;
	void __fastcall SetParameters(Smipars::TSMIParameters* Value);
	Db::TDataSet* __fastcall GetDataSet(void);
	void __fastcall SetDataSet(Db::TDataSet* AValue);
	void __fastcall SetMappings(Classes::TStrings* AValue);
	void __fastcall SetAbout(const System::AnsiString Value);
	void __fastcall SetLoadCondition(TSMILoadCondition* Value);
	void __fastcall SetSQLOptions(TSMISQLOptions* Value);
	System::AnsiString __fastcall Translate(const System::AnsiString s, bool IsEncrypt);
	
protected:
	System::Variant vLocate;
	System::Variant vValues;
	System::Variant vFields;
	int intCurrentParsedFieldIndex;
	Classes::TStream* DataStream;
	Smistat::TfrmSMIProcess* frmSMIProcess;
	bool __fastcall CreateProgressDlg(System::AnsiString strCaption, System::AnsiString strMessage, System::AnsiString 
		strBtnCaption, System::AnsiString strProcessed, System::AnsiString strErrors, System::AnsiString strAdded
		, System::AnsiString strUpdated, System::AnsiString strDeleted, bool ShowAnimated, bool ShowExtendedInfo
		);
	void __fastcall ChangeProgressDlg(int MinValue, int MaxValue, int Progress);
	bool __fastcall DestroyProgressDlg(void);
	bool __fastcall UpdateProgressDlg(System::AnsiString strMessage, int Progress, int intErrors, int intAdded
		, int intDeleted, int intUpdated, int intSkipped);
	bool __fastcall ProgressCanceled(void);
	int __fastcall GetFieldItem(const System::AnsiString FieldName);
	System::AnsiString __fastcall GetTableName();
	bool __fastcall IsGoodRow(int i);
	virtual void __fastcall Prepare(void);
	virtual void __fastcall BeforeImport(void);
	virtual void __fastcall AfterImport(void);
	virtual void __fastcall BuildArrayIntersection(void);
	virtual void __fastcall BuildFieldMapping(void);
	virtual bool __fastcall LoadRecord(void);
	virtual void __fastcall GoFirst(void);
	virtual void __fastcall GoNext(void);
	virtual bool __fastcall NeedMore(void);
	virtual int __fastcall GetTotalCount(void);
	virtual System::Variant __fastcall GetValues(const System::AnsiString strValues);
	virtual System::Variant __fastcall GetFieldValue(const System::Variant &v);
	virtual System::Variant __fastcall GetParsedValue(const System::Variant &v, int intFieldIndex);
	virtual bool __fastcall FieldIsTruncated(void);
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation
		);
	virtual bool __fastcall NotDefined(System::AnsiString &strProperty);
	void __fastcall CreateDirIfNotExists(const System::AnsiString s);
	System::AnsiString __fastcall GetKeyList(Db::TDataSet* DS);
	void __fastcall FillKey4Locate(void);
	void __fastcall FillKey4Values(void);
	void __fastcall SetFieldDelimiter(TSMIFieldDelimiter Value);
	void __fastcall SetFieldDelimiterCustom(char Value);
	void __fastcall SetTextQualifier(TSMITextQualifier Value);
	void __fastcall SetTextQualifierCustom(char Value);
	void __fastcall SetRecordSeparator(TSMIRecordSeparator Value);
	void __fastcall SetRecordSeparatorCustom(System::AnsiString Value);
	void __fastcall ReplaceHTMLChars(System::AnsiString &Value);
	virtual bool __fastcall BLOBIsMIME(void);
	TSMIDataType __fastcall GetSMIDataType(Db::TFieldType DataType);
	void __fastcall ParserEvaluate(System::TObject* Sender, System::AnsiString Eval, const System::Variant 
		* Args, const int Args_Size, int ArgCount, bool IsChild, System::Variant &Value, bool &Done);
	System::AnsiString __fastcall BuildTimeFormat(bool ToAddPrefix);
	System::AnsiString __fastcall BuildDTFormat();
	__property TTableTypeImport TableType = {read=FTableType, write=FTableType, default=2};
	
public:
	__fastcall virtual TSMImportBaseComponent(Classes::TComponent* AOwner);
	__fastcall virtual ~TSMImportBaseComponent(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	bool __fastcall AskParameters(void);
	void __fastcall Execute(void);
	virtual void __fastcall LoadFromStream(Classes::TStream* AStream);
	void __fastcall AboutSMI(void);
	/* virtual class method */ virtual System::AnsiString __fastcall Extension() { Extension(__classid(TSMImportBaseComponent)
		); }
	/*         class method */ static System::AnsiString __fastcall Extension(System::TMetaClass* vmt);
		
	/* virtual class method */ virtual System::AnsiString __fastcall FillFileFilters() { FillFileFilters(__classid(TSMImportBaseComponent)
		); }
	/*         class method */ static System::AnsiString __fastcall FillFileFilters(System::TMetaClass* vmt
		);
	virtual void __fastcall DetectAutoMapping(void);
	virtual void __fastcall Columns2Mapping(void);
	virtual System::AnsiString __fastcall GetColumnFieldName(int Index);
	void __fastcall LoadSpecification(System::AnsiString strFileName);
	void __fastcall SaveSpecification(System::AnsiString SpecName, System::AnsiString FileName, bool ShowDialog
		);
	virtual void __fastcall LoadSpecificationFromStrings(Classes::TStrings* lstSpec);
	void __fastcall LoadSpecificationFromStream(Classes::TStream* Stream);
	virtual void __fastcall SaveSpecificationToStream(Classes::TStream* Stream, const System::AnsiString 
		SpecName);
	__property TSMIColumns* Columns = {read=FColumns};
	__property TSMIFieldDelimiter FieldDelimiter = {read=FFieldDelimiter, write=SetFieldDelimiter, default=2
		};
	__property char FieldDelimiterCustom = {read=FFieldDelimiterCustom, write=SetFieldDelimiterCustom, 
		default=9};
	__property TSMITextQualifier TextQualifier = {read=FTextQualifier, write=SetTextQualifier, default=2
		};
	__property char TextQualifierCustom = {read=FTextQualifierCustom, write=SetTextQualifierCustom, default=34
		};
	__property TSMIRecordSeparator RecordSeparator = {read=FRecordSeparator, write=SetRecordSeparator, 
		default=1};
	__property System::AnsiString RecordSeparatorCustom = {read=FRecordSeparatorCustom, write=SetRecordSeparatorCustom
		};
	__property System::AnsiString SourceFileName = {read=FSourceFileName, write=FSourceFileName};
	__property bool Fixed = {read=FFixed, write=FFixed, nodefault};
	__property int RowFirst = {read=FRowFirst, write=FRowFirst, default=1};
	__property int RowLast = {read=FRowLast, write=FRowLast, default=2147483647};
	__property int RowFieldNames = {read=FRowFieldNames, write=FRowFieldNames, default=1};
	
__published:
	__property System::AnsiString About = {read=FAbout, write=SetAbout};
	__property bool AbortOnProblem = {read=FAbortOnProblem, write=FAbortOnProblem, nodefault};
	__property TSMIActionKind ActionKind = {read=FActionKind, write=FActionKind, default=0};
	__property bool AnimatedStatus = {read=FAnimatedStatus, write=FAnimatedStatus, nodefault};
	__property TSMICharacterSet CharacterSet = {read=FCharacterSet, write=FCharacterSet, default=0};
	__property TSMIDataFormats* DataFormats = {read=FDataFormats, write=FDataFormats};
	__property Db::TDataSet* DataSet = {read=GetDataSet, write=SetDataSet};
	__property System::AnsiString DatasetKeys = {read=FDatasetKeys, write=FDatasetKeys};
	__property TSMILoadCondition* LoadCondition = {read=FLoadCondition, write=SetLoadCondition};
	__property TSMISQLOptions* SQLOptions = {read=FSQLOptions, write=SetSQLOptions};
	__property Classes::TStrings* Mappings = {read=FMappings, write=SetMappings};
	__property TImportMode Mode = {read=FMode, write=FMode, default=0};
	__property TSMIOptions Options = {read=FOptions, write=FOptions, default=59};
	__property Smipars::TSMIParameters* Parameters = {read=FParameters, write=SetParameters};
	__property System::AnsiString TableName = {read=FTableName, write=FTableName};
	__property System::AnsiString TitleStatus = {read=FTitleStatus, write=FTitleStatus};
	__property TSMIStatistic* Statistic = {read=FStatistic, write=FStatistic};
	__property System::AnsiString SpecificationDir = {read=FSpecificationDir, write=FSpecificationDir};
		
	__property bool UseDisplayNames = {read=FUseDisplayNames, write=FUseDisplayNames, nodefault};
	__property TSMITrimSpaces TrimSpaces = {read=FTrimSpaces, write=FTrimSpaces, default=0};
	__property int CommitCount = {read=FCommitCount, write=FCommitCount, default=300};
	__property TErrorEvent OnErrorEvent = {read=FOnErrorEvent, write=FOnErrorEvent};
	__property TGetCellParamsEvent OnGetCellParams = {read=FOnGetCellParams, write=FOnGetCellParams};
	__property TSMIParsedValue OnParsedValue = {read=FOnParsedValue, write=FOnParsedValue};
	__property Smipars::TOnEvaluate OnParserEvaluate = {read=FOnParserEvaluate, write=FOnParserEvaluate
		};
	__property Classes::TNotifyEvent OnBeforeExecute = {read=FOnBeforeExecute, write=FOnBeforeExecute};
		
	__property Classes::TNotifyEvent OnAfterExecute = {read=FOnAfterExecute, write=FOnAfterExecute};
	__property TBeforeRecordEvent OnBeforeRecordEvent = {read=FOnBeforeRecordEvent, write=FOnBeforeRecordEvent
		};
	__property TAfterRecordEvent OnAfterRecordEvent = {read=FOnAfterRecordEvent, write=FOnAfterRecordEvent
		};
	__property TSMIGetRowMode OnGetRowMode = {read=FOnGetRowMode, write=FOnGetRowMode};
	__property Classes::TNotifyEvent OnBeforeUpdate = {read=FOnBeforeUpdate, write=FOnBeforeUpdate};
	__property TBeforeFieldEvent OnBeforeFieldUpdate = {read=FOnBeforeFieldUpdate, write=FOnBeforeFieldUpdate
		};
	__property TSMISpecificationEvent OnBeforeLoadSpecification = {read=FOnBeforeLoadSpecification, write=
		FOnBeforeLoadSpecification};
	__property TSMISpecificationEvent OnAfterLoadSpecification = {read=FOnAfterLoadSpecification, write=
		FOnAfterLoadSpecification};
	__property TSMISpecificationEvent OnBeforeSaveSpecification = {read=FOnBeforeSaveSpecification, write=
		FOnBeforeSaveSpecification};
	__property TSMISpecificationEvent OnAfterSaveSpecification = {read=FOnAfterSaveSpecification, write=
		FOnAfterSaveSpecification};
	__property TLocateRecordEvent OnLocateRecord = {read=FOnLocateRecord, write=FOnLocateRecord};
	__property Classes::TNotifyEvent OnStartTransaction = {read=FOnStartTransaction, write=FOnStartTransaction
		};
	__property Classes::TNotifyEvent OnFinishTransaction = {read=FOnFinishTransaction, write=FOnFinishTransaction
		};
	__property TSMIOnCreateStructure OnCreateStructure = {read=FOnCreateStructure, write=FOnCreateStructure
		};
};

typedef void __fastcall (*TPreviewCallback)(System::TObject* grid, int intColumnCount, int intRecNo, 
	bool IsASCII, const System::Variant &Value);

//-- var, const, procedure ---------------------------------------------------
#define SMIVersion "2.67"
#define MaxRowValue (int)(2147483647)
extern PACKAGE void __fastcall AboutSMImport(void);
extern PACKAGE System::ShortString __fastcall GetDefExt(int intIndex);
extern PACKAGE System::AnsiString __fastcall UECode(bool DOSToWin, System::AnsiString St);
extern PACKAGE System::AnsiString __fastcall EBCDICCode(System::AnsiString s);
extern PACKAGE TImportFormatTypes __fastcall GetAvailableImportFormats(void);

}	/* namespace Smibase */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smibase;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMIBase
