// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIPars.pas' rev: 5.00

#ifndef SMIParsHPP
#define SMIParsHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Smipars
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTokenType { ttNone, ttString, ttNumeric, ttDateTime, ttParenthesis, ttOperation, ttParamDelimitor 
	};
#pragma option pop

typedef void __fastcall (__closure *TOnEvaluate)(System::TObject* Sender, AnsiString Eval, const Variant 
	* Args, const int Args_Size, int ArgCount, bool IsChild, Variant &Value, bool &Done);

class DELPHICLASS TExpToken;
class PASCALIMPLEMENTATION TExpToken : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	AnsiString FText;
	TTokenType FTokenType;
	
public:
	__property AnsiString Text = {read=FText};
	__property TTokenType TokenType = {read=FTokenType, nodefault};
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TExpToken(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TExpToken(void) { }
	#pragma option pop
	
};


class DELPHICLASS TExpParser;
class PASCALIMPLEMENTATION TExpParser : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	AnsiString FExpression;
	Classes::TList* FTokens;
	int FPos;
	
private:
	void __fastcall Clear(void);
	TExpToken* __fastcall GetToken(int Index);
	void __fastcall SetExpression(const AnsiString Value);
	
public:
	__fastcall TExpParser(void);
	__fastcall virtual ~TExpParser(void);
	TExpToken* __fastcall ReadFirstToken(void);
	TExpToken* __fastcall ReadNextToken(void);
	int __fastcall TokenCount(void);
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property Classes::TList* TokenList = {read=FTokens};
	__property AnsiString Expression = {read=FExpression, write=SetExpression};
};


class DELPHICLASS TExpNode;
class PASCALIMPLEMENTATION TExpNode : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	System::TObject* FOwner;
	TExpNode* FParent;
	Classes::TList* FChildren;
	Classes::TList* FTokens;
	int FLevel;
	TExpToken* FToken;
	TOnEvaluate FOnEvaluate;
	
private:
	TExpToken* __fastcall GetToken(int Index);
	TExpNode* __fastcall GetChildren(int Index);
	int __fastcall FindLSOTI(void);
	bool __fastcall ParseFunction(void);
	void __fastcall RemoveSorroundingParenthesis(void);
	void __fastcall SplitToChildren(int TokenIndex);
	Variant __fastcall Evaluate();
	__property TExpNode* Children[int Index] = {read=GetChildren};
	
public:
	__fastcall TExpNode(System::TObject* AOwner, TExpNode* AParent, Classes::TList* Tokens);
	__fastcall virtual ~TExpNode(void);
	void __fastcall Build(void);
	int __fastcall TokenCount(void);
	Variant __fastcall Calculate();
	__property TExpToken* Tokens[int Index] = {read=GetToken};
	__property TExpNode* Parent = {read=FParent};
	__property int Level = {read=FLevel, nodefault};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
};


class DELPHICLASS TSMIParser;
class PASCALIMPLEMENTATION TSMIParser : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FProcessBeforeEvent;
	AnsiString FText;
	TOnEvaluate FOnEvaluate;
	Variant FValue;
	
protected:
	void __fastcall Compile(bool ToCalculate);
	Variant __fastcall GetValue();
	void __fastcall Evaluate(AnsiString Eval, const Variant * Args, const int Args_Size, bool IsChild, 
		Variant &Value);
	
public:
	__fastcall virtual TSMIParser(Classes::TComponent* AOwner);
	void __fastcall Validate(void);
	__property Variant Value = {read=GetValue};
	
__published:
	__property bool ProcessBeforeEvent = {read=FProcessBeforeEvent, write=FProcessBeforeEvent, nodefault
		};
	__property AnsiString Text = {read=FText, write=FText};
	__property TOnEvaluate OnEvaluate = {read=FOnEvaluate, write=FOnEvaluate};
public:
	#pragma option push -w-inl
	/* TComponent.Destroy */ inline __fastcall virtual ~TSMIParser(void) { }
	#pragma option pop
	
};


typedef Variant SMIPars__6[11];

class DELPHICLASS TSMIParserFunction;
class PASCALIMPLEMENTATION TSMIParserFunction : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	AnsiString FAsString;
	AnsiString FName;
	AnsiString FFunction;
	AnsiString FDescription;
	AnsiString FHint;
	System::TObject* FOwner;
	int FArgCount;
	Classes::TStringList* FArgs;
	Variant FValues[11];
	AnsiString FCategory;
	AnsiString FSubCategory;
	
private:
	void __fastcall SetAsString(const AnsiString Value);
	void __fastcall EvalArgs(System::TObject* Sender, AnsiString Eval, const Variant * Args, const int 
		Args_Size, int ArgCount, Variant &Value);
	
protected:
	void __fastcall ApplyArguments(const Variant * Values, const int Values_Size);
	
public:
	__fastcall TSMIParserFunction(System::TObject* AOwner);
	__fastcall virtual ~TSMIParserFunction(void);
	virtual Variant __fastcall Calculate();
	__property AnsiString AsString = {read=FAsString, write=SetAsString};
	__property AnsiString Name = {read=FName};
	__property int ArgCount = {read=FArgCount, nodefault};
	__property Classes::TStringList* Args = {read=FArgs};
	__property AnsiString Description = {read=FDescription, write=FDescription};
	__property AnsiString Hint = {read=FHint, write=FHint};
	__property AnsiString Category = {read=FCategory, write=FCategory};
	__property AnsiString SubCategory = {read=FSubCategory, write=FSubCategory};
};


class DELPHICLASS TSMIParserFunctions;
class PASCALIMPLEMENTATION TSMIParserFunctions : public Classes::TList 
{
	typedef Classes::TList inherited;
	
public:
	__fastcall virtual ~TSMIParserFunctions(void);
	TSMIParserFunction* __fastcall AddFunction(const AnsiString Value);
	HIDESBASE void __fastcall Remove(int Index);
	TSMIParserFunction* __fastcall GetFunction(int Index);
	TSMIParserFunction* __fastcall FunctionByName(AnsiString FuncName);
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TSMIParserFunctions(void) : Classes::TList() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TSMIParameterEditor { ipeEdit, ipeMemo, ipeCheckBox, ipeCombobox, ipeListBox };
#pragma option pop

#pragma option push -b-
enum TSMIParameterMode { ipmCalculate, ipmCalculateAndAsk, ipmAsk };
#pragma option pop

class DELPHICLASS TSMIParameter;
class PASCALIMPLEMENTATION TSMIParameter : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	AnsiString FName;
	AnsiString FCaption;
	AnsiString FDescription;
	AnsiString FExpression;
	TSMIParameterEditor FParameterEditor;
	TSMIParameterMode FParameterMode;
	Classes::TStrings* FParamPromptValues;
	bool FRequired;
	void __fastcall SetParamPromptValues(Classes::TStrings* Value);
	void __fastcall SetName(AnsiString Value);
	
public:
	Variant Value;
	__fastcall virtual TSMIParameter(Classes::TCollection* Collection);
	__fastcall virtual ~TSMIParameter(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property AnsiString Name = {read=FName, write=SetName};
	__property AnsiString Expression = {read=FExpression, write=FExpression};
	__property AnsiString Description = {read=FDescription, write=FDescription};
	__property Classes::TStrings* ParamPromptValues = {read=FParamPromptValues, write=SetParamPromptValues
		};
	__property TSMIParameterEditor ParameterEditor = {read=FParameterEditor, write=FParameterEditor, default=0
		};
	__property TSMIParameterMode ParameterMode = {read=FParameterMode, write=FParameterMode, default=1}
		;
	__property bool Required = {read=FRequired, write=FRequired, default=0};
};


class DELPHICLASS TSMIParameters;
class PASCALIMPLEMENTATION TSMIParameters : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FSMIControl;
	TSMIParameter* __fastcall GetParameter(int Index);
	void __fastcall SetParameter(int Index, TSMIParameter* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TSMIParameters(Classes::TComponent* SMICntrl);
	HIDESBASE TSMIParameter* __fastcall Add(void);
	TSMIParameter* __fastcall ParamByName(const AnsiString Value);
	__property Classes::TComponent* SMIControl = {read=FSMIControl};
	__property TSMIParameter* Items[int Index] = {read=GetParameter, write=SetParameter/*, default*/};
public:
		
	#pragma option push -w-inl
	/* TCollection.Destroy */ inline __fastcall virtual ~TSMIParameters(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint MAXPARAMCOUNT = 0xa;
extern PACKAGE TSMIParserFunctions* lstSMIRegFunctions;
extern PACKAGE System::TDateTime __fastcall GetDTByMask(AnsiString AValue, AnsiString AFormat, char 
	ADateSeparator, char ATimeSeparator);
extern PACKAGE AnsiString __fastcall GetNextItem(char chSeparator, AnsiString &s, bool IsVal, bool IsLastToken
	);
extern PACKAGE bool __fastcall StringIsNumeric(AnsiString Value);
extern PACKAGE AnsiString __fastcall ReplaceStr(AnsiString s, AnsiString oldPattern, AnsiString newPattern
	, bool IgnoreCase, bool ReplaceAll);
extern PACKAGE WideString __fastcall ReplaceWideStr(WideString s, WideString oldPattern, WideString 
	newPattern, bool IgnoreCase, bool ReplaceAll);

}	/* namespace Smipars */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smipars;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// SMIPars
